JSONTokener (Grails 6.0.0)

Package: org.grails.web.json

## [Java] Class JSONTokener

- org.grails.web.json.JSONTokener

-     public class JSONTokener
      extends java.lang.Object

  A JSONTokener takes a source string and extracts characters and tokens from it. It is used by the JSONObject and JSONArray constructors to parse JSON source strings.

  Authors:
    JSON.org
  Version:
    2

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `private int` | `myIndex` | The index of the next character.
    `private java.lang.String` | `mySource` | The source string being tokenized.

  - ### Constructor Summary

    Constructors
    Constructor and description
    `JSONTokener (java.lang.String s)` Construct a JSONTokener from a string.

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `public void` | `back()` Back up one character.
    `` | `public static int` | `dehexchar(char c)` Get the hex value of a character (base16).
    `` | `public boolean` | `more()` Determine if the source string still contains characters that next() can consume.
    `` | `public char` | `next()` Get the next character in the source string.
    `` | `public char` | `next(char c)` Consume the next character, and check that it matches a specified character.
    `` | `public java.lang.String` | `next(int n)` Get the next n characters.
    `` | `public char` | `nextClean()` Get the next char in the string, skipping whitespace and comments (slashslash, slashstar, and hash).
    `` | `public java.lang.String` | `nextString(char quote)` Return the characters up to the next close quote character.
    `` | `public java.lang.String` | `nextTo(char d)` Get the text up but not including the specified character or the end of line, whichever comes first.
    `` | `public java.lang.String` | `nextTo(java.lang.String delimiters)` Get the text up but not including one of the specified delimeter characters or the end of line, whichever comes first.
    `` | `public java.lang.Object` | `nextValue()` Get the next value.
    `` | `public void` | `skipPast(java.lang.String to)` Skip characters until past the requested string.
    `` | `public char` | `skipTo(char to)` Skip characters until the next character is the requested character.
    `` | `public JSONException` | `syntaxError(java.lang.String message)` Make a JSONException to signal a syntax error.
    `` | `public java.lang.String` | `toRegexSafeString()` Make a regex safe printable string of this JSONTokener.
    `` | `public java.lang.String` | `toString()` Make a printable string of this JSONTokener.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class java.lang.Object` | `java.lang.Object#wait(long), java.lang.Object#wait(long, int), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()`

- - ### Field Detail

    - #### private int myIndex

      The index of the next character.

    - #### private java.lang.String mySource

      The source string being tokenized.

  - ### Constructor Detail

    - #### public JSONTokener(java.lang.String s)

      Construct a JSONTokener from a string.

      Parameters:
        `s` - A source string.

  - ### Method Detail

    - #### public void back()

      Back up one character. This provides a sort of lookahead capability, so that you can test for a digit or letter before attempting to parse the next number or identifier.

    - #### public static int dehexchar(char c)

      Get the hex value of a character (base16).

      Parameters:
        `c` - A character between '0' and '9' or between 'A' and 'F' or between 'a' and 'f'.
      Returns:
        An int between 0 and 15, or -1 if c was not a hex digit.

    - #### public boolean more()

      Determine if the source string still contains characters that next() can consume.

      Returns:
        true if not yet at the end of the source.

    - #### public char next()

      Get the next character in the source string.

      Returns:
        The next character, or 0 if past the end of the source string.

    - #### public char next(char c)

      Consume the next character, and check that it matches a specified character.

      throws:
        JSONException if the character does not match.
      Parameters:
        `c` - The character to match.
      Returns:
        The character.

    - #### public java.lang.String next(int n)

      Get the next n characters.

      throws:
        JSONException Substring bounds error if there are not n characters remaining in the source string.
      Parameters:
        `n` - The number of characters to take.
      Returns:
        A string of n characters.

    - #### public char nextClean()

      Get the next char in the string, skipping whitespace and comments (slashslash, slashstar, and hash).

      throws:
        JSONException
      Returns:
        A character, or 0 if there are no more characters.

    - #### public java.lang.String nextString(char quote)

      Return the characters up to the next close quote character. Backslash processing is done. The formal JSON format does not allow strings in single quotes, but an implementation is allowed to accept them.

      throws:
        JSONException Unterminated string.
      Parameters:
        `quote` - The quoting character, either `"` (double quote) or `'` (single quote).
      Returns:
        A String.

    - #### public java.lang.String nextTo(char d)

      Get the text up but not including the specified character or the end of line, whichever comes first.

      Parameters:
        `d` - A delimiter character.
      Returns:
        A string.

    - #### public java.lang.String nextTo(java.lang.String delimiters)

      Get the text up but not including one of the specified delimeter characters or the end of line, whichever comes first.

      Parameters:
        `delimiters` - A set of delimiter characters.
      Returns:
        A string, trimmed.

    - #### public java.lang.Object nextValue()

      Get the next value. The value can be a Boolean, Double, Integer, JSONArray, JSONObject, Long, or String, or the JSONObject.NULL object.

      throws:
        JSONException If syntax error.
      Returns:
        An object.

    - #### public void skipPast(java.lang.String to)

      Skip characters until past the requested string. If it is not found, we are left at the end of the source.

      Parameters:
        `to` - A string to skip past.

    - #### public char skipTo(char to)

      Skip characters until the next character is the requested character. If the requested character is not found, no characters are skipped.

      Parameters:
        `to` - A character to skip to.
      Returns:
        The requested character, or zero if the requested character is not found.

    - #### public JSONException syntaxError(java.lang.String message)

      Make a JSONException to signal a syntax error.

      Parameters:
        `message` - The error message.
      Returns:
        A JSONException object, suitable for throwing

    - #### public java.lang.String toRegexSafeString()

      Make a regex safe printable string of this JSONTokener.

      Returns:
        " at character [this.myIndex] of [this.mySource]"

    - #### @java.lang.Override public java.lang.String toString()

      Make a printable string of this JSONTokener.

      Returns:
        " at character [this.myIndex] of [this.mySource]"